# Variable util`Const`

util: { ExpScaler: ((z: number[]) => number[]); LogScaler: ((z: number[]) => number[]); MAD: ((actuals: number[], estimates: number[]) => number); MADMeanRatio: ((actuals: number[], estimates: number[]) => number); MAPE: ((actuals: number[], estimates: number[]) => number); MFE: ((actuals: number[], estimates: number[]) => number); MMR: ((actuals: number[], estimates: number[]) => number); MSE: ((actuals: number[], estimates: number[]) => number); MinMaxScaler: ((z: number[]) => number[]); MinMaxScalerTransforms: ((vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents) => ScaledTransforms); StandardScaler: ((z: number[]) => number[]); StandardScalerTransforms: ((vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents) => ScaledTransforms); TS: ((actuals: number[], estimates: number[]) => number); adjustedCoefficentOfDetermination: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number); adjustedRSquared: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number); approximateZPercentile: ((z: number, alpha?: boolean) => number); avg: ArrayCalculation; coefficientOfCorrelation: ((actuals?: number[], estimates?: number[]) => number); coefficientOfDetermination: ((actuals?: number[], estimates?: number[]) => number); forecastErrors: ((actuals: number[], estimates: number[]) => number[]); getSafePropertyName: ((name: string) => string); max: ArraySort; mean: ArrayCalculation; meanAbsoluteDeviation: ((actuals: number[], estimates: number[]) => number); meanAbsolutePercentageError: ((actuals: number[], estimates: number[]) => number); meanForecastError: ((actuals: number[], estimates: number[]) => number); meanSquaredError: ((actuals: number[], estimates: number[]) => number); min: ArraySort; pivotArrays: ((arrays?: Matrix) => Matrix); pivotVector: ((vectors?: any[][]) => Matrix); r: ((actuals?: number[], estimates?: number[]) => number); rBarSquared: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number); rSquared: ((actuals??: number[], estimates??: number[]) => number); range: { (start: number, end?: number, step?: number): number[]; (end: number, index: string | number, guard: object): number[] }; rangeRight: { (start: number, end?: number, step?: number): number[]; (end: number, index: string | number, guard: object): number[] }; scale: ((a: number[], d: number) => number[]); sd: ArrayCalculation; squaredDifference: ((left: number[], right: number[]) => number[]); standardError: ((actuals?: number[], estimates?: number[]) => number); standardScore: ((observations?: number[]) => number[]); sum: ArrayCalculation; trackingSignal: ((actuals: number[], estimates: number[]) => number); zScore: ((observations?: number[]) => number[]) } = ...

### Namespace

#### Type declaration

- ##### ExpScaler: ((z: number[]) => number[])

  - - (z: number[]): number[]

    - #### Parameters

      - ##### z: number[]

      #### Returns number[]

- ##### LogScaler: ((z: number[]) => number[])

  - - (z: number[]): number[]

    - #### Parameters

      - ##### z: number[]

      #### Returns number[]

- ##### MAD: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - Mean Absolute Deviation (MAD) indicates the absolute size of the errors

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MAD = ms.util.meanAbsoluteDeviation(actuals, estimates); // =>  3.5

      ### Returns

      MAD

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MADMeanRatio: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - MAD over Mean Ratio - The MAD/Mean ratio is an alternative to the MAPE that is better suited to intermittent and low-volume data. As stated previously, percentage errors cannot be calculated when the actual equals zero and can take on extreme values when dealing with low-volume data. These issues become magnified when you start to average MAPEs over multiple time series. The MAD/Mean ratio tries to overcome this problem by dividing the MAD by the Mean—essentially rescaling the error to make it comparable across time series of varying scales

      ### Member Of

      util

      ### See

      https://www.forecastpro.com/Trends/forecasting101August2011.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MMR = ms.util.MADMeanRatio(actuals, estimates);
           MAPE.toFixed(2) // => 0.08

      ### Returns

      MMR

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MAPE: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - MAPE (Mean Absolute Percent Error) measures the size of the error in percentage terms

      ### Member Of

      util

      ### See

      https://www.forecastpro.com/Trends/forecasting101August2011.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MAPE = ms.util.meanAbsolutePercentageError(actuals, estimates);
           MAPE.toFixed(2) // => 0.86

      ### Returns

      MAPE

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MFE: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - The bias of forecast accuracy

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MFE = ms.util.meanForecastError(actuals, estimates); // =>  -0.5

      ### Returns

      MFE (bias)

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MMR: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - MAD over Mean Ratio - The MAD/Mean ratio is an alternative to the MAPE that is better suited to intermittent and low-volume data. As stated previously, percentage errors cannot be calculated when the actual equals zero and can take on extreme values when dealing with low-volume data. These issues become magnified when you start to average MAPEs over multiple time series. The MAD/Mean ratio tries to overcome this problem by dividing the MAD by the Mean—essentially rescaling the error to make it comparable across time series of varying scales

      ### Member Of

      util

      ### See

      https://www.forecastpro.com/Trends/forecasting101August2011.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MMR = ms.util.MADMeanRatio(actuals, estimates);
           MAPE.toFixed(2) // => 0.08

      ### Returns

      MMR

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MSE: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - The standard error of the estimate is a measure of the accuracy of predictions made with a regression line. Compares the estimate to the actual value

      ### Member Of

      util

      ### See

      http://onlinestatbook.com/2/regression/accuracy.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MSE = ms.util.meanSquaredError(actuals, estimates); // => 13.5

      ### Returns

      MSE

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### MinMaxScaler: ((z: number[]) => number[])

  - - (z: number[]): number[]

    - Transforms features by scaling each feature to a given range. This estimator scales and translates each feature individually such that it is in the given range on the training set, i.e. between zero and one. *

      ### Member Of

      util *

      ### Returns

      #### Parameters

      - ##### z: number[]

        array of integers or floats *

      #### Returns number[]

- ##### MinMaxScalerTransforms: ((vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents) => ScaledTransforms)

  - - (vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents): ScaledTransforms

    - This function returns two functions that can mix max scale new inputs and reverse scale new outputs

      ### Returns

      - {scale[ Function ], descale[ Function ]}

      #### Parameters

      - ##### vector: never[] = []

      - ##### nan_value: number = -1

      - ##### return_nan: boolean = false

      - ##### inputComponents: InputComponents = {}

      #### Returns ScaledTransforms

- ##### StandardScaler: ((z: number[]) => number[])

  - - (z: number[]): number[]

    - Standardize features by removing the mean and scaling to unit variance

      Centering and scaling happen independently on each feature by computing the relevant statistics on the samples in the training set. Mean and standard deviation are then stored to be used on later data using the transform method.

      Standardization of a dataset is a common requirement for many machine learning estimators: they might behave badly if the individual feature do not more or less look like standard normally distributed data (e.g. Gaussian with 0 mean and unit variance)

      ### Member Of

      util

      ### Returns

      #### Parameters

      - ##### z: number[]

        array of integers or floats

      #### Returns number[]

- ##### StandardScalerTransforms: ((vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents) => ScaledTransforms)

  - - (vector?: never[], nan_value?: number, return_nan?: boolean, inputComponents?: InputComponents): ScaledTransforms

    - This function returns two functions that can standard scale new inputs and reverse scale new outputs

      ### Returns

      - {scale[ Function ], descale[ Function ]}

      #### Parameters

      - ##### vector: never[] = []

      - ##### nan_value: number = -1

      - ##### return_nan: boolean = false

      - ##### inputComponents: InputComponents = {}

      #### Returns ScaledTransforms

- ##### TS: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - Tracking Signal - Used to pinpoint forecasting models that need adjustment

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const trackingSignal = ms.util.trackingSignal(actuals, estimates);
           trackingSignal.toFixed(2) // =>  -0.57

      ### Returns

      trackingSignal

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### adjustedCoefficentOfDetermination: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number)

  - - (options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }): number

    - You can use the adjusted coefficient of determination to determine how well a multiple regression equation “fits” the sample data. The adjusted coefficient of determination is closely related to the coefficient of determination (also known as R2) that you use to test the results of a simple regression equation.

      ### Example

          const adjr2 = ms.util.adjustedCoefficentOfDetermination({
           rSquared: 0.944346527,
           sampleSize: 8,
           independentVariables: 2,
          });
          r2.toFixed(3) // => 0.922

      ### Member Of

      util

      ### See

      http://www.dummies.com/education/math/business-statistics/how-to-calculate-the-adjusted-coefficient-of-determination/

      ### Returns

      adjusted r^2 for multiple linear regression

      #### Parameters

      - ##### `Optional` options: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }

        - ##### actuals: number[]

          numerical samples

        - ##### estimates: number[]

          estimate values

        - ##### independentVariables: number

          the number of independent variables in the regression equation

        - ##### rSquared: number

          coefficent of determination

        - ##### sampleSize: number

          the sample size

      #### Returns number

- ##### adjustedRSquared: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number)

  - - (options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }): number

    - You can use the adjusted coefficient of determination to determine how well a multiple regression equation “fits” the sample data. The adjusted coefficient of determination is closely related to the coefficient of determination (also known as R2) that you use to test the results of a simple regression equation.

      ### Example

          const adjr2 = ms.util.adjustedCoefficentOfDetermination({
           rSquared: 0.944346527,
           sampleSize: 8,
           independentVariables: 2,
          });
          r2.toFixed(3) // => 0.922

      ### Member Of

      util

      ### See

      http://www.dummies.com/education/math/business-statistics/how-to-calculate-the-adjusted-coefficient-of-determination/

      ### Returns

      adjusted r^2 for multiple linear regression

      #### Parameters

      - ##### `Optional` options: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }

        - ##### actuals: number[]

          numerical samples

        - ##### estimates: number[]

          estimate values

        - ##### independentVariables: number

          the number of independent variables in the regression equation

        - ##### rSquared: number

          coefficent of determination

        - ##### sampleSize: number

          the sample size

      #### Returns number

- ##### approximateZPercentile: ((z: number, alpha?: boolean) => number)

  - - (z: number, alpha?: boolean): number

    - Converts z-score into the probability

      ### Member Of

      util

      ### See

      https://stackoverflow.com/questions/36575743/how-do-i-convert-probability-into-z-score

      ### Returns

      p - p-value

      #### Parameters

      - ##### z: number

        Number of standard deviations from the mean.

      - ##### alpha: boolean = true

      #### Returns number

- ##### avg: ArrayCalculation

- ##### coefficientOfCorrelation: ((actuals?: number[], estimates?: number[]) => number)

  - - (actuals?: number[], estimates?: number[]): number

    - The coefficent of Correlation is given by R decides how well the given data fits a line or a curve.

      ### Example

          const actuals = [ 39, 42, 67, 76, ];
          const estimates = [ 44, 40, 60, 84, ];
          const R = ms.util.coefficientOfCorrelation(actuals, estimates);
          R.toFixed(4) // => 0.9408

      ### Member Of

      util

      ### See

      https://calculator.tutorvista.com/r-squared-calculator.html

      ### Returns

      R

      #### Parameters

      - ##### actuals: number[] = []

        numerical samples

      - ##### estimates: number[] = []

        estimates values

      #### Returns number

- ##### coefficientOfDetermination: ((actuals?: number[], estimates?: number[]) => number)

  - - (actuals?: number[], estimates?: number[]): number

    - In statistics, the coefficient of determination, denoted R2 or r2 and pronounced "R squared", is the proportion of the variance in the dependent variable that is predictable from the independent variable(s). Compares distance of estimated values to the mean. {\bar {y}}={\frac {1}{n}}\sum {i=1}^{n}y{i}

      ### Example

          const actuals = [ 2, 4, 5, 4, 5, ];
          const estimates = [ 2.8, 3.4, 4, 4.6, 5.2, ];
          const r2 = ms.util.coefficientOfDetermination(actuals, estimates);
          r2.toFixed(1) // => 0.6

      ### Member Of

      util

      ### See

      https://en.wikipedia.org/wiki/Coefficient_of_determination http://statisticsbyjim.com/regression/standard-error-regression-vs-r-squared/

      ### Returns

      r^2

      #### Parameters

      - ##### actuals: number[] = []

        numerical samples

      - ##### estimates: number[] = []

        estimates values

      #### Returns number

- ##### forecastErrors: ((actuals: number[], estimates: number[]) => number[])

  - - (actuals: number[], estimates: number[]): number[]

    - The errors (residuals) from acutals and estimates

      ### Member Of

      util

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const errors = ms.util.forecastErrors(actuals, estimates); // => [ 4, -5, 2, -3 ]

      ### Returns

      errors (residuals)

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number[]

- ##### getSafePropertyName: ((name: string) => string)

  - - (name: string): string

    - returns a safe column name / url slug from a string

      ### Returns

      #### Parameters

      - ##### name: string

      #### Returns string

- ##### max: ArraySort

- ##### mean: ArrayCalculation

- ##### meanAbsoluteDeviation: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - Mean Absolute Deviation (MAD) indicates the absolute size of the errors

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MAD = ms.util.meanAbsoluteDeviation(actuals, estimates); // =>  3.5

      ### Returns

      MAD

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### meanAbsolutePercentageError: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - MAPE (Mean Absolute Percent Error) measures the size of the error in percentage terms

      ### Member Of

      util

      ### See

      https://www.forecastpro.com/Trends/forecasting101August2011.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MAPE = ms.util.meanAbsolutePercentageError(actuals, estimates);
           MAPE.toFixed(2) // => 0.86

      ### Returns

      MAPE

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### meanForecastError: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - The bias of forecast accuracy

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MFE = ms.util.meanForecastError(actuals, estimates); // =>  -0.5

      ### Returns

      MFE (bias)

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### meanSquaredError: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - The standard error of the estimate is a measure of the accuracy of predictions made with a regression line. Compares the estimate to the actual value

      ### Member Of

      util

      ### See

      http://onlinestatbook.com/2/regression/accuracy.html

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const MSE = ms.util.meanSquaredError(actuals, estimates); // => 13.5

      ### Returns

      MSE

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### min: ArraySort

- ##### pivotArrays: ((arrays?: Matrix) => Matrix)

  - - (arrays?: Matrix): Matrix

    - returns a matrix of values by combining arrays into a matrix

      ### Member Of

      util

      ### Example

          const arrays = [
             [ 1, 1, 3, 3 ],
             [ 2, 2, 3, 3 ],
             [ 3, 3, 4, 3 ],
           ];
           pivotArrays(arrays); //=>
           // [
           //   [1, 2, 3,],
           //   [1, 2, 3,],
           //   [3, 3, 4,],
           //   [3, 3, 3,],
           // ];
           *

      ### Returns

      a matrix of column values

      #### Parameters

      - ##### arrays: Matrix = []

      #### Returns Matrix

- ##### pivotVector: ((vectors?: any[][]) => Matrix)

  - - (vectors?: any[][]): Matrix

    - returns an array of vectors as an array of arrays

      ### Example

          const vectors = [ [1,2,3], [1,2,3], [3,3,4], [3,3,3] ];
          const arrays = pivotVector(vectors); // => [ [1,2,3,3], [2,2,3,3], [3,3,4,3] ];

      ### Member Of

      util

      ### Returns

      #### Parameters

      - ##### vectors: any[][] = []

      #### Returns Matrix

- ##### r: ((actuals?: number[], estimates?: number[]) => number)

  - - (actuals?: number[], estimates?: number[]): number

    - The coefficent of Correlation is given by R decides how well the given data fits a line or a curve.

      ### Example

          const actuals = [ 39, 42, 67, 76, ];
          const estimates = [ 44, 40, 60, 84, ];
          const R = ms.util.coefficientOfCorrelation(actuals, estimates);
          R.toFixed(4) // => 0.9408

      ### Member Of

      util

      ### See

      https://calculator.tutorvista.com/r-squared-calculator.html

      ### Returns

      R

      #### Parameters

      - ##### actuals: number[] = []

        numerical samples

      - ##### estimates: number[] = []

        estimates values

      #### Returns number

- ##### rBarSquared: ((options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }) => number)

  - - (options?: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }): number

    - You can use the adjusted coefficient of determination to determine how well a multiple regression equation “fits” the sample data. The adjusted coefficient of determination is closely related to the coefficient of determination (also known as R2) that you use to test the results of a simple regression equation.

      ### Example

          const adjr2 = ms.util.adjustedCoefficentOfDetermination({
           rSquared: 0.944346527,
           sampleSize: 8,
           independentVariables: 2,
          });
          r2.toFixed(3) // => 0.922

      ### Member Of

      util

      ### See

      http://www.dummies.com/education/math/business-statistics/how-to-calculate-the-adjusted-coefficient-of-determination/

      ### Returns

      adjusted r^2 for multiple linear regression

      #### Parameters

      - ##### `Optional` options: { actuals: number[]; estimates: number[]; independentVariables: number; rSquared: number; sampleSize: number }

        - ##### actuals: number[]

          numerical samples

        - ##### estimates: number[]

          estimate values

        - ##### independentVariables: number

          the number of independent variables in the regression equation

        - ##### rSquared: number

          coefficent of determination

        - ##### sampleSize: number

          the sample size

      #### Returns number

- ##### rSquared: ((actuals??: number[], estimates??: number[]) => number)

  - - (actuals??: number[], estimates??: number[]): number

    - The coefficent of determination is given by r^2 decides how well the given data fits a line or a curve.

      ### Returns

      r^2

      #### Parameters

      - ##### `Optional` actuals: number[] = []

      - ##### `Optional` estimates: number[] = []

      #### Returns number

- ##### range: { (start: number, end?: number, step?: number): number[]; (end: number, index: string | number, guard: object): number[] }

  - - (start: number, end?: number, step?: number): number[]

    - Creates an array of numbers (positive and/or negative) progressing from start up to, but not including, end. If end is not specified it’s set to start with start then set to 0. If end is less than start a zero-length range is created unless a negative step is specified.

      ### Returns

      Returns a new range array.

      #### Parameters

      - ##### start: number

        The start of the range.

      - ##### `Optional` end: number

        The end of the range.

      - ##### `Optional` step: number

        The value to increment or decrement by.

      #### Returns number[]

    - (end: number, index: string | number, guard: object): number[]

    - ### See

      _.range

      #### Parameters

      - ##### end: number

      - ##### index: string | number

      - ##### guard: object

      #### Returns number[]

- ##### rangeRight: { (start: number, end?: number, step?: number): number[]; (end: number, index: string | number, guard: object): number[] }

  - - (start: number, end?: number, step?: number): number[]

    - This method is like `_.range` except that it populates values in descending order.

      ### Returns

      Returns the new array of numbers.

      ### Example

          _.rangeRight(4);
          // => [3, 2, 1, 0]

          _.rangeRight(-4);
          // => [-3, -2, -1, 0]

          _.rangeRight(1, 5);
          // => [4, 3, 2, 1]

          _.rangeRight(0, 20, 5);
          // => [15, 10, 5, 0]

          _.rangeRight(0, -4, -1);
          // => [-3, -2, -1, 0]

          _.rangeRight(1, 4, 0);
          // => [1, 1, 1]

          _.rangeRight(0);
          // => []

      #### Parameters

      - ##### start: number

        The start of the range.

      - ##### `Optional` end: number

        The end of the range.

      - ##### `Optional` step: number

        The value to increment or decrement by.

      #### Returns number[]

    - (end: number, index: string | number, guard: object): number[]

    - ### See

      _.rangeRight

      #### Parameters

      - ##### end: number

      - ##### index: string | number

      - ##### guard: object

      #### Returns number[]

- ##### scale: ((a: number[], d: number) => number[])

  - - (a: number[], d: number): number[]

    - #### Parameters

      - ##### a: number[]

      - ##### d: number

      #### Returns number[]

- ##### sd: ArrayCalculation

- ##### squaredDifference: ((left: number[], right: number[]) => number[])

  - - (left: number[], right: number[]): number[]

    - Returns an array of the squared different of two arrays

      ### Member Of

      util

      ### Returns

      Squared difference of left minus right array

      #### Parameters

      - ##### left: number[]

      - ##### right: number[]

      #### Returns number[]

- ##### standardError: ((actuals?: number[], estimates?: number[]) => number)

  - - (actuals?: number[], estimates?: number[]): number

    - The standard error of the estimate is a measure of the accuracy of predictions made with a regression line. Compares the estimate to the actual value

      ### Member Of

      util

      ### See

      http://onlinestatbook.com/2/regression/accuracy.html

      ### Example

          const actuals = [ 2, 4, 5, 4, 5, ];
           const estimates = [ 2.8, 3.4, 4, 4.6, 5.2, ];
           const SE = ms.util.standardError(actuals, estimates);
           SE.toFixed(2) // => 0.89

      ### Returns

      Standard Error of the Estimate

      #### Parameters

      - ##### actuals: number[] = []

        numerical samples

      - ##### estimates: number[] = []

        estimates values

      #### Returns number

- ##### standardScore: ((observations?: number[]) => number[])

  - - (observations?: number[]): number[]

    - Calculates the z score of each value in the sample, relative to the sample mean and standard deviation.

      ### Member Of

      util

      ### See

      https://docs.scipy.org/doc/scipy-0.14.0/reference/generated/scipy.stats.mstats.zscore.html

      ### Returns

      The z-scores, standardized by mean and standard deviation of input array

      #### Parameters

      - ##### observations: number[] = []

        An array like object containing the sample data.

      #### Returns number[]

- ##### sum: ArrayCalculation

- ##### trackingSignal: ((actuals: number[], estimates: number[]) => number)

  - - (actuals: number[], estimates: number[]): number

    - Tracking Signal - Used to pinpoint forecasting models that need adjustment

      ### Member Of

      util

      ### See

      https://scm.ncsu.edu/scm-articles/article/measuring-forecast-accuracy-approaches-to-forecasting-a-tutorial

      ### Example

          const actuals = [ 45, 38, 43, 39 ];
           const estimates = [ 41, 43, 41, 42 ];
           const trackingSignal = ms.util.trackingSignal(actuals, estimates);
           trackingSignal.toFixed(2) // =>  -0.57

      ### Returns

      trackingSignal

      #### Parameters

      - ##### actuals: number[]

        numerical samples

      - ##### estimates: number[]

        estimates values

      #### Returns number

- ##### zScore: ((observations?: number[]) => number[])

  - - (observations?: number[]): number[]

    - Calculates the z score of each value in the sample, relative to the sample mean and standard deviation.

      ### Member Of

      util

      ### See

      https://docs.scipy.org/doc/scipy-0.14.0/reference/generated/scipy.stats.mstats.zscore.html

      ### Returns

      The z-scores, standardized by mean and standard deviation of input array

      #### Parameters

      - ##### observations: number[] = []

        An array like object containing the sample data.

      #### Returns number[]

- Defined in src/util.ts:551